Index: /branches/version-2_11-dev/data/module/fpdf/fpdf.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20993)
@@ -615,64 +599,64 @@
 function Cell($w, $h=0, $txt='', $border=0, $ln=0, $align='', $fill=false, $link='')
 {
-	//Output a cell
-	$k=$this->k;
+	// Output a cell
+	$k = $this->k;
 	if($this->y+$h>$this->PageBreakTrigger && !$this->InHeader && !$this->InFooter && $this->AcceptPageBreak())
 	{
-		//Automatic page break
-		$x=$this->x;
-		$ws=$this->ws;
+		// Automatic page break
+		$x = $this->x;
+		$ws = $this->ws;
 		if($ws>0)
 		{
-			$this->ws=0;
+			$this->ws = 0;
 			$this->_out('0 Tw');
 		}
-		$this->AddPage($this->CurOrientation,$this->CurPageFormat);
-		$this->x=$x;
+		$this->AddPage($this->CurOrientation,$this->CurPageSize);
+		$this->x = $x;
 		if($ws>0)
 		{
-			$this->ws=$ws;
+			$this->ws = $ws;
 			$this->_out(sprintf('%.3F Tw',$ws*$k));
 		}
 	}
 	if($w==0)
-		$w=$this->w-$this->rMargin-$this->x;
-	$s='';
+		$w = $this->w-$this->rMargin-$this->x;
+	$s = '';
 	if($fill || $border==1)
 	{
 		if($fill)
-			$op=($border==1) ? 'B' : 'f';
+			$op = ($border==1) ? 'B' : 'f';
 		else
-			$op='S';
-		$s=sprintf('%.2F %.2F %.2F %.2F re %s ',$this->x*$k,($this->h-$this->y)*$k,$w*$k,-$h*$k,$op);
+			$op = 'S';
+		$s = sprintf('%.2F %.2F %.2F %.2F re %s ',$this->x*$k,($this->h-$this->y)*$k,$w*$k,-$h*$k,$op);
 	}
 	if(is_string($border))
 	{
-		$x=$this->x;
-		$y=$this->y;
+		$x = $this->x;
+		$y = $this->y;
 		if(strpos($border,'L')!==false)
-			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,$x*$k,($this->h-($y+$h))*$k);
+			$s .= sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,$x*$k,($this->h-($y+$h))*$k);
 		if(strpos($border,'T')!==false)
-			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-$y)*$k);
+			$s .= sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-$y)*$k);
 		if(strpos($border,'R')!==false)
-			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',($x+$w)*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
+			$s .= sprintf('%.2F %.2F m %.2F %.2F l S ',($x+$w)*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
 		if(strpos($border,'B')!==false)
-			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-($y+$h))*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
+			$s .= sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-($y+$h))*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
 	}
 	if($txt!=='')
 	{
 		if($align=='R')
-			$dx=$w-$this->cMargin-$this->GetStringWidth($txt);
+			$dx = $w-$this->cMargin-$this->GetStringWidth($txt);
 		elseif($align=='C')
-			$dx=($w-$this->GetStringWidth($txt))/2;
+			$dx = ($w-$this->GetStringWidth($txt))/2;
 		else
-			$dx=$this->cMargin;
+			$dx = $this->cMargin;
 		if($this->ColorFlag)
-			$s.='q '.$this->TextColor.' ';
-		$txt2=str_replace(')','\\)',str_replace('(','\\(',str_replace('\\','\\\\',$txt)));
-		$s.=sprintf('BT %.2F %.2F Td (%s) Tj ET',($this->x+$dx)*$k,($this->h-($this->y+.5*$h+.3*$this->FontSize))*$k,$txt2);
+			$s .= 'q '.$this->TextColor.' ';
+		$txt2 = str_replace(')','\\)',str_replace('(','\\(',str_replace('\\','\\\\',$txt)));
+		$s .= sprintf('BT %.2F %.2F Td (%s) Tj ET',($this->x+$dx)*$k,($this->h-($this->y+.5*$h+.3*$this->FontSize))*$k,$txt2);
 		if($this->underline)
-			$s.=' '.$this->_dounderline($this->x+$dx,$this->y+.5*$h+.3*$this->FontSize,$txt);
+			$s .= ' '.$this->_dounderline($this->x+$dx,$this->y+.5*$h+.3*$this->FontSize,$txt);
 		if($this->ColorFlag)
-			$s.=' Q';
+			$s .= ' Q';
 		if($link)
 			$this->Link($this->x+$dx,$this->y+.5*$h-.5*$this->FontSize,$this->GetStringWidth($txt),$this->FontSize,$link);
@@ -680,85 +664,85 @@
 	if($s)
 		$this->_out($s);
-	$this->lasth=$h;
+	$this->lasth = $h;
 	if($ln>0)
 	{
-		//Go to next line
-		$this->y+=$h;
+		// Go to next line
+		$this->y += $h;
 		if($ln==1)
-			$this->x=$this->lMargin;
-	}
-	else
-		$this->x+=$w;
+			$this->x = $this->lMargin;
+	}
+	else
+		$this->x += $w;
 }
 
 function MultiCell($w, $h, $txt, $border=0, $align='J', $fill=false)
 {
-	//Output text with automatic or explicit line breaks
-	$cw=&$this->CurrentFont['cw'];
+	// Output text with automatic or explicit line breaks
+	$cw = &$this->CurrentFont['cw'];
 	if($w==0)
-		$w=$this->w-$this->rMargin-$this->x;
-	$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
-	$s=str_replace("\r",'',$txt);
-	$nb=strlen($s);
+		$w = $this->w-$this->rMargin-$this->x;
+	$wmax = ($w-2*$this->cMargin)*1000/$this->FontSize;
+	$s = str_replace("\r",'',$txt);
+	$nb = strlen($s);
 	if($nb>0 && $s[$nb-1]=="\n")
 		$nb--;
-	$b=0;
+	$b = 0;
 	if($border)
 	{
 		if($border==1)
 		{
-			$border='LTRB';
-			$b='LRT';
-			$b2='LR';
+			$border = 'LTRB';
+			$b = 'LRT';
+			$b2 = 'LR';
 		}
 		else
 		{
-			$b2='';
+			$b2 = '';
 			if(strpos($border,'L')!==false)
-				$b2.='L';
+				$b2 .= 'L';
 			if(strpos($border,'R')!==false)
-				$b2.='R';
-			$b=(strpos($border,'T')!==false) ? $b2.'T' : $b2;
-		}
-	}
-	$sep=-1;
-	$i=0;
-	$j=0;
-	$l=0;
-	$ns=0;
-	$nl=1;
+				$b2 .= 'R';
+			$b = (strpos($border,'T')!==false) ? $b2.'T' : $b2;
+		}
+	}
+	$sep = -1;
+	$i = 0;
+	$j = 0;
+	$l = 0;
+	$ns = 0;
+	$nl = 1;
 	while($i<$nb)
 	{
-		//Get next character
-		$c=$s[$i];
+		// Get next character
+		$c = $s[$i];
 		if($c=="\n")
 		{
-			//Explicit line break
+			// Explicit line break
 			if($this->ws>0)
 			{
-				$this->ws=0;
+				$this->ws = 0;
 				$this->_out('0 Tw');
 			}
 			$this->Cell($w,$h,substr($s,$j,$i-$j),$b,2,$align,$fill);
 			$i++;
-			$sep=-1;
-			$j=$i;
-			$l=0;
-			$ns=0;
+			$sep = -1;
+			$j = $i;
+			$l = 0;
+			$ns = 0;
 			$nl++;
 			if($border && $nl==2)
-				$b=$b2;
+				$b = $b2;
 			continue;
 		}
 		if($c==' ')
 		{
-			$sep=$i;
-			$ls=$l;
+			$sep = $i;
+			$ls = $l;
 			$ns++;
 		}
-		$l+=$cw[$c];
+		$l += $cw[$c];
 		if($l>$wmax)
 		{
-			//Automatic line break
+			// Automatic line break
 			if($sep==-1)
 			{
@@ -767,5 +751,5 @@
 				if($this->ws>0)
 				{
-					$this->ws=0;
+					$this->ws = 0;
 					$this->_out('0 Tw');
 				}
@@ -776,63 +760,63 @@
 				if($align=='J')
 				{
-					$this->ws=($ns>1) ? ($wmax-$ls)/1000*$this->FontSize/($ns-1) : 0;
+					$this->ws = ($ns>1) ? ($wmax-$ls)/1000*$this->FontSize/($ns-1) : 0;
 					$this->_out(sprintf('%.3F Tw',$this->ws*$this->k));
 				}
 				$this->Cell($w,$h,substr($s,$j,$sep-$j),$b,2,$align,$fill);
-				$i=$sep+1;
+				$i = $sep+1;
 			}
-			$sep=-1;
-			$j=$i;
-			$l=0;
-			$ns=0;
+			$sep = -1;
+			$j = $i;
+			$l = 0;
+			$ns = 0;
 			$nl++;
 			if($border && $nl==2)
-				$b=$b2;
+				$b = $b2;
 		}
 		else
 			$i++;
 	}
-	//Last chunk
+	// Last chunk
 	if($this->ws>0)
 	{
-		$this->ws=0;
+		$this->ws = 0;
 		$this->_out('0 Tw');
 	}
 	if($border && strpos($border,'B')!==false)
-		$b.='B';
+		$b .= 'B';
 	$this->Cell($w,$h,substr($s,$j,$i-$j),$b,2,$align,$fill);
-	$this->x=$this->lMargin;
+	$this->x = $this->lMargin;
 }
 
 function Write($h, $txt, $link='')
 {
-	//Output text in flowing mode
-	$cw=&$this->CurrentFont['cw'];
-	$w=$this->w-$this->rMargin-$this->x;
-	$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
-	$s=str_replace("\r",'',$txt);
-	$nb=strlen($s);
-	$sep=-1;
-	$i=0;
-	$j=0;
-	$l=0;
-	$nl=1;
+	// Output text in flowing mode
+	$cw = &$this->CurrentFont['cw'];
+	$w = $this->w-$this->rMargin-$this->x;
+	$wmax = ($w-2*$this->cMargin)*1000/$this->FontSize;
+	$s = str_replace("\r",'',$txt);
+	$nb = strlen($s);
+	$sep = -1;
+	$i = 0;
+	$j = 0;
+	$l = 0;
+	$nl = 1;
 	while($i<$nb)
 	{
-		//Get next character
-		$c=$s[$i];
+		// Get next character
+		$c = $s[$i];
 		if($c=="\n")
 		{
-			//Explicit line break
+			// Explicit line break
 			$this->Cell($w,$h,substr($s,$j,$i-$j),0,2,'',0,$link);
 			$i++;
-			$sep=-1;
-			$j=$i;
-			$l=0;
+			$sep = -1;
+			$j = $i;
+			$l = 0;
 			if($nl==1)
 			{
-				$this->x=$this->lMargin;
-				$w=$this->w-$this->rMargin-$this->x;
-				$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
+				$this->x = $this->lMargin;
+				$w = $this->w-$this->rMargin-$this->x;
+				$wmax = ($w-2*$this->cMargin)*1000/$this->FontSize;
 			}
 			$nl++;
@@ -840,18 +824,18 @@
 		}
 		if($c==' ')
-			$sep=$i;
-		$l+=$cw[$c];
+			$sep = $i;
+		$l += $cw[$c];
 		if($l>$wmax)
 		{
-			//Automatic line break
+			// Automatic line break
 			if($sep==-1)
 			{
 				if($this->x>$this->lMargin)
 				{
-					//Move to next line
-					$this->x=$this->lMargin;
-					$this->y+=$h;
-					$w=$this->w-$this->rMargin-$this->x;
-					$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
+					// Move to next line
+					$this->x = $this->lMargin;
+					$this->y += $h;
+					$w = $this->w-$this->rMargin-$this->x;
+					$wmax = ($w-2*$this->cMargin)*1000/$this->FontSize;
 					$i++;
 					$nl++;
@@ -865,14 +849,14 @@
 			{
 				$this->Cell($w,$h,substr($s,$j,$sep-$j),0,2,'',0,$link);
-				$i=$sep+1;
+				$i = $sep+1;
 			}
-			$sep=-1;
-			$j=$i;
-			$l=0;
+			$sep = -1;
+			$j = $i;
+			$l = 0;
 			if($nl==1)
 			{
-				$this->x=$this->lMargin;
-				$w=$this->w-$this->rMargin-$this->x;
-				$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
+				$this->x = $this->lMargin;
+				$w = $this->w-$this->rMargin-$this->x;
+				$wmax = ($w-2*$this->cMargin)*1000/$this->FontSize;
 			}
 			$nl++;
@@ -881,5 +865,5 @@
 			$i++;
 	}
-	//Last chunk
+	// Last chunk
 	if($i!=$j)
 		$this->Cell($l/1000*$this->FontSize,$h,substr($s,$j),0,0,'',0,$link);
@@ -888,63 +872,70 @@
 function Ln($h=null)
 {
-	//Line feed; default value is last cell height
-	$this->x=$this->lMargin;
+	// Line feed; default value is last cell height
+	$this->x = $this->lMargin;
 	if($h===null)
-		$this->y+=$this->lasth;
-	else
-		$this->y+=$h;
+		$this->y += $this->lasth;
+	else
+		$this->y += $h;
 }
 
 function Image($file, $x=null, $y=null, $w=0, $h=0, $type='', $link='')
 {
-	//Put an image on the page
+	// Put an image on the page
 	if(!isset($this->images[$file]))
 	{
-		//First use of this image, get info
+		// First use of this image, get info
 		if($type=='')
 		{
-			$pos=strrpos($file,'.');
+			$pos = strrpos($file,'.');
 			if(!$pos)
 				$this->Error('Image file has no extension and no type was specified: '.$file);
-			$type=substr($file,$pos+1);
-		}
-		$type=strtolower($type);
+			$type = substr($file,$pos+1);
+		}
+		$type = strtolower($type);
 		if($type=='jpeg')
-			$type='jpg';
-		$mtd='_parse'.$type;
+			$type = 'jpg';
+		$mtd = '_parse'.$type;
 		if(!method_exists($this,$mtd))
 			$this->Error('Unsupported image type: '.$type);
-		$info=$this->$mtd($file);
-		$info['i']=count($this->images)+1;
-		$this->images[$file]=$info;
-	}
-	else
-		$info=$this->images[$file];
-	//Automatic width and height calculation if needed
+		$info = $this->$mtd($file);
+		$info['i'] = count($this->images)+1;
+		$this->images[$file] = $info;
+	}
+	else
+		$info = $this->images[$file];
+
+	// Automatic width and height calculation if needed
 	if($w==0 && $h==0)
 	{
-		//Put image at 72 dpi
-		$w=$info['w']/$this->k;
-		$h=$info['h']/$this->k;
-	}
-	elseif($w==0)
-		$w=$h*$info['w']/$info['h'];
-	elseif($h==0)
-		$h=$w*$info['h']/$info['w'];
-	//Flowing mode
+		// Put image at 96 dpi
+		$w = -96;
+		$h = -96;
+	}
+	if($w<0)
+		$w = -$info['w']*72/$w/$this->k;
+	if($h<0)
+		$h = -$info['h']*72/$h/$this->k;
+	if($w==0)
+		$w = $h*$info['w']/$info['h'];
+	if($h==0)
+		$h = $w*$info['h']/$info['w'];
+
+	// Flowing mode
 	if($y===null)
 	{
 		if($this->y+$h>$this->PageBreakTrigger && !$this->InHeader && !$this->InFooter && $this->AcceptPageBreak())
 		{
-			//Automatic page break
-			$x2=$this->x;
-			$this->AddPage($this->CurOrientation,$this->CurPageFormat);
-			$this->x=$x2;
-		}
-		$y=$this->y;
-		$this->y+=$h;
-	}
+			// Automatic page break
+			$x2 = $this->x;
+			$this->AddPage($this->CurOrientation,$this->CurPageSize);
+			$this->x = $x2;
+		}
+		$y = $this->y;
+		$this->y += $h;
+	}
+
 	if($x===null)
-		$x=$this->x;
+		$x = $this->x;
 	$this->_out(sprintf('q %.2F 0 0 %.2F %.2F %.2F cm /I%d Do Q',$w*$this->k,$h*$this->k,$x*$this->k,($this->h-($y+$h))*$this->k,$info['i']));
 	if($link)
@@ -954,5 +945,5 @@
 function GetX()
 {
-	//Get x position
+	// Get x position
 	return $this->x;
 }
@@ -960,14 +951,14 @@
 function SetX($x)
 {
-	//Set x position
+	// Set x position
 	if($x>=0)
-		$this->x=$x;
-	else
-		$this->x=$this->w+$x;
+		$this->x = $x;
+	else
+		$this->x = $this->w+$x;
 }
 
 function GetY()
 {
-	//Get y position
+	// Get y position
 	return $this->y;
 }
@@ -975,15 +966,15 @@
 function SetY($y)
 {
-	//Set y position and reset x
-	$this->x=$this->lMargin;
+	// Set y position and reset x
+	$this->x = $this->lMargin;
 	if($y>=0)
-		$this->y=$y;
-	else
-		$this->y=$this->h+$y;
+		$this->y = $y;
+	else
+		$this->y = $this->h+$y;
 }
 
 function SetXY($x, $y)
 {
-	//Set x and y positions
+	// Set x and y positions
 	$this->SetY($y);
 	$this->SetX($x);
@@ -992,55 +983,45 @@
 function Output($name='', $dest='')
 {
-	//Output PDF to some destination
+	// Output PDF to some destination
 	if($this->state<3)
 		$this->Close();
-	$dest=strtoupper($dest);
+	$dest = strtoupper($dest);
 	if($dest=='')
 	{
 		if($name=='')
 		{
-			$name='doc.pdf';
-			$dest='I';
+			$name = 'doc.pdf';
+			$dest = 'I';
 		}
 		else
-			$dest='F';
+			$dest = 'F';
 	}
 	switch($dest)
 	{
 		case 'I':
-			//Send to standard output
-			if(ob_get_length())
-				$this->Error('Some data has already been output, can\'t send PDF file');
-			if(php_sapi_name()!='cli')
+			// Send to standard output
+			$this->_checkoutput();
+			if(PHP_SAPI!='cli')
 			{
-				//We send to a browser
+				// We send to a browser
 				header('Content-Type: application/pdf');
-				if(headers_sent())
-					$this->Error('Some data has already been output, can\'t send PDF file');
-				header('Content-Length: '.strlen($this->buffer));
 				header('Content-Disposition: inline; filename="'.$name.'"');
 				header('Cache-Control: private, max-age=0, must-revalidate');
 				header('Pragma: public');
-				ini_set('zlib.output_compression','0');
 			}
 			echo $this->buffer;
 			break;
 		case 'D':
-			//Download file
-			if(ob_get_length())
-				$this->Error('Some data has already been output, can\'t send PDF file');
+			// Download file
+			$this->_checkoutput();
 			header('Content-Type: application/x-download');
-			if(headers_sent())
-				$this->Error('Some data has already been output, can\'t send PDF file');
-			header('Content-Length: '.strlen($this->buffer));
 			header('Content-Disposition: attachment; filename="'.$name.'"');
 			header('Cache-Control: private, max-age=0, must-revalidate');
 			header('Pragma: public');
-			ini_set('zlib.output_compression','0');
 			echo $this->buffer;
 			break;
 		case 'F':
-			//Save to local file
-			$f=fopen($name,'wb');
+			// Save to local file
+			$f = fopen($name,'wb');
 			if(!$f)
 				$this->Error('Unable to create output file: '.$name);
@@ -1049,5 +1030,5 @@
 			break;
 		case 'S':
-			//Return as a string
+			// Return as a string
 			return $this->buffer;
 		default:
@@ -1064,86 +1045,116 @@
 function _dochecks()
 {
-	//Check availability of %F
+	// Check availability of %F
 	if(sprintf('%.1F',1.0)!='1.0')
 		$this->Error('This version of PHP is not supported');
-	//Check mbstring overloading
+	// Check mbstring overloading
 	if(ini_get('mbstring.func_overload') & 2)
 		$this->Error('mbstring overloading must be disabled');
-	//Disable runtime magic quotes
+	// Ensure runtime magic quotes are disabled
 	if(get_magic_quotes_runtime())
 		@set_magic_quotes_runtime(0);
 }
 
-function _getpageformat($format)
-{
-	$format=strtolower($format);
-	if(!isset($this->PageFormats[$format]))
-		$this->Error('Unknown page format: '.$format);
-	$a=$this->PageFormats[$format];
-	return array($a[0]/$this->k, $a[1]/$this->k);
-}
-
-function _getfontpath()
-{
-	if(!defined('FPDF_FONTPATH') && is_dir(dirname(__FILE__).'/font'))
-		define('FPDF_FONTPATH',dirname(__FILE__).'/font/');
-	return defined('FPDF_FONTPATH') ? FPDF_FONTPATH : '';
-}
-
-function _beginpage($orientation, $format)
+function _checkoutput()
+{
+	if(PHP_SAPI!='cli')
+	{
+		if(headers_sent($file,$line))
+			$this->Error("Some data has already been output, can't send PDF file (output started at $file:$line)");
+	}
+	if(ob_get_length())
+	{
+		// The output buffer is not empty
+		if(preg_match('/^(\xEF\xBB\xBF)?\s*$/',ob_get_contents()))
+		{
+			// It contains only a UTF-8 BOM and/or whitespace, let's clean it
+			ob_clean();
+		}
+		else
+			$this->Error("Some data has already been output, can't send PDF file");
+	}
+}
+
+function _getpagesize($size)
+{
+	if(is_string($size))
+	{
+		$size = strtolower($size);
+		if(!isset($this->StdPageSizes[$size]))
+			$this->Error('Unknown page size: '.$size);
+		$a = $this->StdPageSizes[$size];
+		return array($a[0]/$this->k, $a[1]/$this->k);
+	}
+	else
+	{
+		if($size[0]>$size[1])
+			return array($size[1], $size[0]);
+		else
+			return $size;
+	}
+}
+
+function _beginpage($orientation, $size)
 {
 	$this->page++;
-	$this->pages[$this->page]='';
-	$this->state=2;
-	$this->x=$this->lMargin;
-	$this->y=$this->tMargin;
-	$this->FontFamily='';
-	//Check page size
+	$this->pages[$this->page] = '';
+	$this->state = 2;
+	$this->x = $this->lMargin;
+	$this->y = $this->tMargin;
+	$this->FontFamily = '';
+	// Check page size and orientation
 	if($orientation=='')
-		$orientation=$this->DefOrientation;
-	else
-		$orientation=strtoupper($orientation[0]);
-	if($format=='')
-		$format=$this->DefPageFormat;
-	else
-	{
-		if(is_string($format))
-			$format=$this->_getpageformat($format);
-	}
-	if($orientation!=$this->CurOrientation || $format[0]!=$this->CurPageFormat[0] || $format[1]!=$this->CurPageFormat[1])
-	{
-		//New size
+		$orientation = $this->DefOrientation;
+	else
+		$orientation = strtoupper($orientation[0]);
+	if($size=='')
+		$size = $this->DefPageSize;
+	else
+		$size = $this->_getpagesize($size);
+	if($orientation!=$this->CurOrientation || $size[0]!=$this->CurPageSize[0] || $size[1]!=$this->CurPageSize[1])
+	{
+		// New size or orientation
 		if($orientation=='P')
 		{
-			$this->w=$format[0];
-			$this->h=$format[1];
+			$this->w = $size[0];
+			$this->h = $size[1];
 		}
 		else
 		{
-			$this->w=$format[1];
-			$this->h=$format[0];
-		}
-		$this->wPt=$this->w*$this->k;
-		$this->hPt=$this->h*$this->k;
-		$this->PageBreakTrigger=$this->h-$this->bMargin;
-		$this->CurOrientation=$orientation;
-		$this->CurPageFormat=$format;
-	}
-	if($orientation!=$this->DefOrientation || $format[0]!=$this->DefPageFormat[0] || $format[1]!=$this->DefPageFormat[1])
-		$this->PageSizes[$this->page]=array($this->wPt, $this->hPt);
+			$this->w = $size[1];
+			$this->h = $size[0];
+		}
+		$this->wPt = $this->w*$this->k;
+		$this->hPt = $this->h*$this->k;
+		$this->PageBreakTrigger = $this->h-$this->bMargin;
+		$this->CurOrientation = $orientation;
+		$this->CurPageSize = $size;
+	}
+	if($orientation!=$this->DefOrientation || $size[0]!=$this->DefPageSize[0] || $size[1]!=$this->DefPageSize[1])
+		$this->PageSizes[$this->page] = array($this->wPt, $this->hPt);
 }
 
 function _endpage()
 {
-	$this->state=1;
+	$this->state = 1;
+}
+
+function _loadfont($font)
+{
+	// Load a font definition file from the font directory
+	include($this->fontpath.$font);
+	$a = get_defined_vars();
+	if(!isset($a['name']))
+		$this->Error('Could not include font definition file');
+	return $a;
 }
 
 function _escape($s)
 {
-	//Escape special characters in strings
-	$s=str_replace('\\','\\\\',$s);
-	$s=str_replace('(','\\(',$s);
-	$s=str_replace(')','\\)',$s);
-	$s=str_replace("\r",'\\r',$s);
+	// Escape special characters in strings
+	$s = str_replace('\\','\\\\',$s);
+	$s = str_replace('(','\\(',$s);
+	$s = str_replace(')','\\)',$s);
+	$s = str_replace("\r",'\\r',$s);
 	return $s;
 }
@@ -1151,5 +1162,5 @@
 function _textstring($s)
 {
-	//Format a text string
+	// Format a text string
 	return '('.$this->_escape($s).')';
 }
@@ -1157,30 +1168,30 @@
 function _UTF8toUTF16($s)
 {
-	//Convert UTF-8 to UTF-16BE with BOM
-	$res="\xFE\xFF";
-	$nb=strlen($s);
-	$i=0;
+	// Convert UTF-8 to UTF-16BE with BOM
+	$res = "\xFE\xFF";
+	$nb = strlen($s);
+	$i = 0;
 	while($i<$nb)
 	{
-		$c1=ord($s[$i++]);
+		$c1 = ord($s[$i++]);
 		if($c1>=224)
 		{
-			//3-byte character
-			$c2=ord($s[$i++]);
-			$c3=ord($s[$i++]);
-			$res.=chr((($c1 & 0x0F)<<4) + (($c2 & 0x3C)>>2));
-			$res.=chr((($c2 & 0x03)<<6) + ($c3 & 0x3F));
+			// 3-byte character
+			$c2 = ord($s[$i++]);
+			$c3 = ord($s[$i++]);
+			$res .= chr((($c1 & 0x0F)<<4) + (($c2 & 0x3C)>>2));
+			$res .= chr((($c2 & 0x03)<<6) + ($c3 & 0x3F));
 		}
 		elseif($c1>=192)
 		{
-			//2-byte character
-			$c2=ord($s[$i++]);
-			$res.=chr(($c1 & 0x1C)>>2);
-			$res.=chr((($c1 & 0x03)<<6) + ($c2 & 0x3F));
+			// 2-byte character
+			$c2 = ord($s[$i++]);
+			$res .= chr(($c1 & 0x1C)>>2);
+			$res .= chr((($c1 & 0x03)<<6) + ($c2 & 0x3F));
 		}
 		else
 		{
-			//Single-byte character
-			$res.="\0".chr($c1);
+			// Single-byte character
+			$res .= "\0".chr($c1);
 		}
 	}
@@ -1190,8 +1201,8 @@
 function _dounderline($x, $y, $txt)
 {
-	//Underline text
-	$up=$this->CurrentFont['up'];
-	$ut=$this->CurrentFont['ut'];
-	$w=$this->GetStringWidth($txt)+$this->ws*substr_count($txt,' ');
+	// Underline text
+	$up = $this->CurrentFont['up'];
+	$ut = $this->CurrentFont['ut'];
+	$w = $this->GetStringWidth($txt)+$this->ws*substr_count($txt,' ');
 	return sprintf('%.2F %.2F %.2F %.2F re f',$x*$this->k,($this->h-($y-$up/1000*$this->FontSize))*$this->k,$w*$this->k,-$ut/1000*$this->FontSizePt);
 }
@@ -1199,6 +1210,6 @@
 function _parsejpg($file)
 {
-	//Extract info from a JPEG file
-	$a=GetImageSize($file);
+	// Extract info from a JPEG file
+	$a = getimagesize($file);
 	if(!$a)
 		$this->Error('Missing or incorrect image file: '.$file);
@@ -1206,16 +1217,11 @@
 		$this->Error('Not a JPEG file: '.$file);
 	if(!isset($a['channels']) || $a['channels']==3)
-		$colspace='DeviceRGB';
+		$colspace = 'DeviceRGB';
 	elseif($a['channels']==4)
-		$colspace='DeviceCMYK';
-	else
-		$colspace='DeviceGray';
-	$bpc=isset($a['bits']) ? $a['bits'] : 8;
-	//Read whole file
-	$f=fopen($file,'rb');
-	$data='';
-	while(!feof($f))
-		$data.=fread($f,8192);
-	fclose($f);
+		$colspace = 'DeviceCMYK';
+	else
+		$colspace = 'DeviceGray';
+	$bpc = isset($a['bits']) ? $a['bits'] : 8;
+	$data = file_get_contents($file);
 	return array('w'=>$a[0], 'h'=>$a[1], 'cs'=>$colspace, 'bpc'=>$bpc, 'f'=>'DCTDecode', 'data'=>$data);
 }
@@ -1223,29 +1229,37 @@
 function _parsepng($file)
 {
-	//Extract info from a PNG file
-	$f=fopen($file,'rb');
+	// Extract info from a PNG file
+	$f = fopen($file,'rb');
 	if(!$f)
 		$this->Error('Can\'t open image file: '.$file);
-	//Check signature
+	$info = $this->_parsepngstream($f,$file);
+	fclose($f);
+	return $info;
+}
+
+function _parsepngstream($f, $file)
+{
+	// Check signature
 	if($this->_readstream($f,8)!=chr(137).'PNG'.chr(13).chr(10).chr(26).chr(10))
 		$this->Error('Not a PNG file: '.$file);
-	//Read header chunk
+
+	// Read header chunk
 	$this->_readstream($f,4);
 	if($this->_readstream($f,4)!='IHDR')
 		$this->Error('Incorrect PNG file: '.$file);
-	$w=$this->_readint($f);
-	$h=$this->_readint($f);
-	$bpc=ord($this->_readstream($f,1));
+	$w = $this->_readint($f);
+	$h = $this->_readint($f);
+	$bpc = ord($this->_readstream($f,1));
 	if($bpc>8)
 		$this->Error('16-bit depth not supported: '.$file);
-	$ct=ord($this->_readstream($f,1));
-	if($ct==0)
-		$colspace='DeviceGray';
-	elseif($ct==2)
-		$colspace='DeviceRGB';
+	$ct = ord($this->_readstream($f,1));
+	if($ct==0 || $ct==4)
+		$colspace = 'DeviceGray';
+	elseif($ct==2 || $ct==6)
+		$colspace = 'DeviceRGB';
 	elseif($ct==3)
-		$colspace='Indexed';
-	else
-		$this->Error('Alpha channel not supported: '.$file);
+		$colspace = 'Indexed';
+	else
+		$this->Error('Unknown color type: '.$file);
 	if(ord($this->_readstream($f,1))!=0)
 		$this->Error('Unknown compression method: '.$file);
@@ -1255,32 +1269,33 @@
 		$this->Error('Interlacing not supported: '.$file);
 	$this->_readstream($f,4);
-	$parms='/DecodeParms <</Predictor 15 /Colors '.($ct==2 ? 3 : 1).' /BitsPerComponent '.$bpc.' /Columns '.$w.'>>';
-	//Scan chunks looking for palette, transparency and image data
-	$pal='';
-	$trns='';
-	$data='';
+	$dp = '/Predictor 15 /Colors '.($colspace=='DeviceRGB' ? 3 : 1).' /BitsPerComponent '.$bpc.' /Columns '.$w;
+
+	// Scan chunks looking for palette, transparency and image data
+	$pal = '';
+	$trns = '';
+	$data = '';
 	do
 	{
-		$n=$this->_readint($f);
-		$type=$this->_readstream($f,4);
+		$n = $this->_readint($f);
+		$type = $this->_readstream($f,4);
 		if($type=='PLTE')
 		{
-			//Read palette
-			$pal=$this->_readstream($f,$n);
+			// Read palette
+			$pal = $this->_readstream($f,$n);
 			$this->_readstream($f,4);
 		}
 		elseif($type=='tRNS')
 		{
-			//Read transparency info
-			$t=$this->_readstream($f,$n);
+			// Read transparency info
+			$t = $this->_readstream($f,$n);
 			if($ct==0)
-				$trns=array(ord(substr($t,1,1)));
+				$trns = array(ord(substr($t,1,1)));
 			elseif($ct==2)
-				$trns=array(ord(substr($t,1,1)), ord(substr($t,3,1)), ord(substr($t,5,1)));
+				$trns = array(ord(substr($t,1,1)), ord(substr($t,3,1)), ord(substr($t,5,1)));
 			else
 			{
-				$pos=strpos($t,chr(0));
+				$pos = strpos($t,chr(0));
 				if($pos!==false)
-					$trns=array($pos);
+					$trns = array($pos);
 			}
 			$this->_readstream($f,4);
@@ -1288,6 +1303,6 @@
 		elseif($type=='IDAT')
 		{
-			//Read image data block
-			$data.=$this->_readstream($f,$n);
+			// Read image data block
+			$data .= $this->_readstream($f,$n);
 			$this->_readstream($f,4);
 		}
@@ -1298,21 +1313,65 @@
 	}
 	while($n);
+
 	if($colspace=='Indexed' && empty($pal))
 		$this->Error('Missing palette in '.$file);
-	fclose($f);
-	return array('w'=>$w, 'h'=>$h, 'cs'=>$colspace, 'bpc'=>$bpc, 'f'=>'FlateDecode', 'parms'=>$parms, 'pal'=>$pal, 'trns'=>$trns, 'data'=>$data);
+	$info = array('w'=>$w, 'h'=>$h, 'cs'=>$colspace, 'bpc'=>$bpc, 'f'=>'FlateDecode', 'dp'=>$dp, 'pal'=>$pal, 'trns'=>$trns);
+	if($ct>=4)
+	{
+		// Extract alpha channel
+		if(!function_exists('gzuncompress'))
+			$this->Error('Zlib not available, can\'t handle alpha channel: '.$file);
+		$data = gzuncompress($data);
+		$color = '';
+		$alpha = '';
+		if($ct==4)
+		{
+			// Gray image
+			$len = 2*$w;
+			for($i=0;$i<$h;$i++)
+			{
+				$pos = (1+$len)*$i;
+				$color .= $data[$pos];
+				$alpha .= $data[$pos];
+				$line = substr($data,$pos+1,$len);
+				$color .= preg_replace('/(.)./s','$1',$line);
+				$alpha .= preg_replace('/.(.)/s','$1',$line);
+			}
+		}
+		else
+		{
+			// RGB image
+			$len = 4*$w;
+			for($i=0;$i<$h;$i++)
+			{
+				$pos = (1+$len)*$i;
+				$color .= $data[$pos];
+				$alpha .= $data[$pos];
+				$line = substr($data,$pos+1,$len);
+				$color .= preg_replace('/(.{3})./s','$1',$line);
+				$alpha .= preg_replace('/.{3}(.)/s','$1',$line);
+			}
+		}
+		unset($data);
+		$data = gzcompress($color);
+		$info['smask'] = gzcompress($alpha);
+		if($this->PDFVersion<'1.4')
+			$this->PDFVersion = '1.4';
+	}
+	$info['data'] = $data;
+	return $info;
 }
 
 function _readstream($f, $n)
 {
-	//Read n bytes from stream
-	$res='';
+	// Read n bytes from stream
+	$res = '';
 	while($n>0 && !feof($f))
 	{
-		$s=fread($f,$n);
+		$s = fread($f,$n);
 		if($s===false)
 			$this->Error('Error while reading stream');
-		$n-=strlen($s);
-		$res.=$s;
+		$n -= strlen($s);
+		$res .= $s;
 	}
 	if($n>0)
@@ -1323,6 +1382,6 @@
 function _readint($f)
 {
-	//Read a 4-byte integer from stream
-	$a=unpack('Ni',$this->_readstream($f,4));
+	// Read a 4-byte integer from stream
+	$a = unpack('Ni',$this->_readstream($f,4));
 	return $a['i'];
 }
@@ -1330,21 +1389,38 @@
 function _parsegif($file)
 {
-	//Extract info from a GIF file (via PNG conversion)
+	// Extract info from a GIF file (via PNG conversion)
 	if(!function_exists('imagepng'))
 		$this->Error('GD extension is required for GIF support');
 	if(!function_exists('imagecreatefromgif'))
 		$this->Error('GD has no GIF read support');
-	$im=imagecreatefromgif($file);
+	$im = imagecreatefromgif($file);
 	if(!$im)
 		$this->Error('Missing or incorrect image file: '.$file);
 	imageinterlace($im,0);
-	$tmp=tempnam('.','gif');
-	if(!$tmp)
-		$this->Error('Unable to create a temporary file');
-	if(!imagepng($im,$tmp))
-		$this->Error('Error while saving to temporary file');
-	imagedestroy($im);
-	$info=$this->_parsepng($tmp);
-	unlink($tmp);
+	$f = @fopen('php://temp','rb+');
+	if($f)
+	{
+		// Perform conversion in memory
+		ob_start();
+		imagepng($im);
+		$data = ob_get_clean();
+		imagedestroy($im);
+		fwrite($f,$data);
+		rewind($f);
+		$info = $this->_parsepngstream($f,$file);
+		fclose($f);
+	}
+	else
+	{
+		// Use temporary file
+		$tmp = tempnam('.','gif');
+		if(!$tmp)
+			$this->Error('Unable to create a temporary file');
+		if(!imagepng($im,$tmp))
+			$this->Error('Error while saving to temporary file');
+		imagedestroy($im);
+		$info = $this->_parsepng($tmp);
+		unlink($tmp);
+	}
 	return $info;
 }
@@ -1352,7 +1428,7 @@
 function _newobj()
 {
-	//Begin a new object
+	// Begin a new object
 	$this->n++;
-	$this->offsets[$this->n]=strlen($this->buffer);
+	$this->offsets[$this->n] = strlen($this->buffer);
 	$this->_out($this->n.' 0 obj');
 }
@@ -1367,34 +1443,34 @@
 function _out($s)
 {
-	//Add a line to the document
+	// Add a line to the document
 	if($this->state==2)
-		$this->pages[$this->page].=$s."\n";
-	else
-		$this->buffer.=$s."\n";
+		$this->pages[$this->page] .= $s."\n";
+	else
+		$this->buffer .= $s."\n";
 }
 
 function _putpages()
 {
-	$nb=$this->page;
+	$nb = $this->page;
 	if(!empty($this->AliasNbPages))
 	{
-		//Replace number of pages
+		// Replace number of pages
 		for($n=1;$n<=$nb;$n++)
-			$this->pages[$n]=str_replace($this->AliasNbPages,$nb,$this->pages[$n]);
+			$this->pages[$n] = str_replace($this->AliasNbPages,$nb,$this->pages[$n]);
 	}
 	if($this->DefOrientation=='P')
 	{
-		$wPt=$this->DefPageFormat[0]*$this->k;
-		$hPt=$this->DefPageFormat[1]*$this->k;
-	}
-	else
-	{
-		$wPt=$this->DefPageFormat[1]*$this->k;
-		$hPt=$this->DefPageFormat[0]*$this->k;
-	}
-	$filter=($this->compress) ? '/Filter /FlateDecode ' : '';
+		$wPt = $this->DefPageSize[0]*$this->k;
+		$hPt = $this->DefPageSize[1]*$this->k;
+	}
+	else
+	{
+		$wPt = $this->DefPageSize[1]*$this->k;
+		$hPt = $this->DefPageSize[0]*$this->k;
+	}
+	$filter = ($this->compress) ? '/Filter /FlateDecode ' : '';
 	for($n=1;$n<=$nb;$n++)
 	{
-		//Page
+		// Page
 		$this->_newobj();
 		$this->_out('<</Type /Page');
